Package com.io7m.waxmill.realize

# Class WXMRealizationInstructions.Builder

java.lang.Object
com.io7m.waxmill.realize.WXMRealizationInstructions.Builder

Enclosing class:
  WXMRealizationInstructions

    public static final class WXMRealizationInstructions.Builder
    extends java.lang.Object

Builds instances of type `WXMRealizationInstructions`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `WXMRealizationInstructions.Builder` | `addAllSteps​(java.lang.Iterable<? extends WXMRealizationStepType> elements)` | Adds elements to `steps` list.
  `WXMRealizationInstructions.Builder` | `addSteps​(WXMRealizationStepType element)` | Adds one element to `steps` list.
  `WXMRealizationInstructions.Builder` | `addSteps​(WXMRealizationStepType... elements)` | Adds elements to `steps` list.
  `WXMRealizationInstructions` | `build()` | Builds a new `WXMRealizationInstructions`.
  `WXMRealizationInstructions.Builder` | `from​(WXMRealizationInstructionsType instance)` | Fill a builder with attribute values from the provided `WXMRealizationInstructionsType` instance.
  `WXMRealizationInstructions.Builder` | `setSteps​(java.lang.Iterable<? extends WXMRealizationStepType> elements)` | Sets or replaces all elements for `steps` list.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final WXMRealizationInstructions.Builder from​(WXMRealizationInstructionsType instance)
    Fill a builder with attribute values from the provided `WXMRealizationInstructionsType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values. Collection elements and entries will be added, not replaced.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### addSteps

    public final WXMRealizationInstructions.Builder addSteps​(WXMRealizationStepType element)
    Adds one element to `steps` list.
    Parameters:
      `element` - A steps element
    Returns:
      `this` builder for use in a chained invocation

  - ### addSteps

    public final WXMRealizationInstructions.Builder addSteps​(WXMRealizationStepType... elements)
    Adds elements to `steps` list.
    Parameters:
      `elements` - An array of steps elements
    Returns:
      `this` builder for use in a chained invocation

  - ### setSteps

    public final WXMRealizationInstructions.Builder setSteps​(java.lang.Iterable<? extends WXMRealizationStepType> elements)
    Sets or replaces all elements for `steps` list.
    Parameters:
      `elements` - An iterable of steps elements
    Returns:
      `this` builder for use in a chained invocation

  - ### addAllSteps

    public final WXMRealizationInstructions.Builder addAllSteps​(java.lang.Iterable<? extends WXMRealizationStepType> elements)
    Adds elements to `steps` list.
    Parameters:
      `elements` - An iterable of steps elements
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public WXMRealizationInstructions build()
    Builds a new `WXMRealizationInstructions`.
    Returns:
      An immutable instance of WXMRealizationInstructions
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing